---
title: Range.commonAncestorContainer
slug: Web/API/Range/commonAncestorContainer
tags:
  - API
  - DOM
  - Property
  - Range
---
<div>{{ApiRef("DOM")}}</div>

<p>The <code><strong>Range.commonAncestorContainer</strong></code><strong> </strong>read-only property returns the deepest — or furthest down the document tree — {{domxref("Node")}} that contains both <a href="http://www.w3.org/TR/DOM-Level-2-Traversal-Range/ranges.html#Level-2-Range-Position-h3">boundary points</a> of the {{domxref("Range")}}. This means that if {{domxref("Range.startContainer")}} and {{domxref("Range.endContainer")}} both refer to the same node, this node is the <strong>common ancestor container</strong>.</p>

<p>Since a <code>Range</code> need not be continuous, and may also partially select nodes, this is a convenient way to find a <code>Node</code> which encloses a <code>Range</code>.</p>

<p>This property is read-only. To change the ancestor container of a <code>Node</code>, consider using the various methods available to set the start and end positions of the <code>Range</code>, such as {{domxref("Range.setStart()")}} and {{domxref("Range.setEnd()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rangeAncestor</em> = <em>range</em>.commonAncestorContainer;</pre>

<h2 id="Example">Example</h2>

<p>In this example, we create an event listener to handle {{Event("pointerup")}} events on a list. The listener gets the common ancestors of each piece of selected text, and triggers an animation to highlight them.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;ul&gt;
  &lt;li&gt;Strings
    &lt;ul&gt;
      &lt;li&gt;Cello&lt;/li&gt;
      &lt;li&gt;Violin
        &lt;ul&gt;
          &lt;li&gt;First Chair&lt;/li&gt;
          &lt;li&gt;Second Chair&lt;/li&gt;
        &lt;/ul&gt;
      &lt;/li&gt;
    &lt;/ul&gt;
  &lt;/li&gt;
  &lt;li&gt;Woodwinds
    &lt;ul&gt;
      &lt;li&gt;Clarinet&lt;/li&gt;
      &lt;li&gt;Oboe&lt;/li&gt;
    &lt;/ul&gt;
  &lt;/li&gt;
&lt;/ul&gt;</pre>

<h3 id="CSS">CSS</h3>

<p>The <code>.highlight</code> class created below uses a set of CSS {{cssxref("@keyframes")}} to animate a fading outline.</p>

<pre class="brush: css">.highlight {
  animation: highlight linear 1s;
}

@keyframes highlight {
  from { outline: 1px solid #f00f; }
  to   { outline: 1px solid #f000; }
}</pre>

<div class="hidden">
<pre class="brush: css">body {
  padding: 1px;
}</pre>
</div>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">document.addEventListener('pointerup', e =&gt; {
  const selection = window.getSelection();

  if (selection.type === 'Range') {
    for (let i = 0; i &lt; selection.rangeCount; i++) {
      const range = selection.getRangeAt(i);
      playAnimation(range.commonAncestorContainer);
    }
  }
});

function playAnimation(el) {
  if (el.nodeType === Node.TEXT_NODE) {
    el = el.parentNode;
  }

  el.classList.remove('highlight');
  setTimeout(() =&gt; {
    el.classList.add('highlight');
  }, 0);
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", 700, 190)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-range-commonancestorcontainer', 'Range.commonAncestorContainer')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level-2-Range-attr-commonParent', 'Range.commonAncestorContainer')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range.commonAncestorContainer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
